(* File lexer.mll *)
{
  open Parser        (* The type token is defined in parser.mli *)
  exception Eof
}
let ident = ['a'-'z' 'A'-'Z' '_']['a'-'z' 'A'-'Z' '_' '0'-'9']*

let white = [' ' '\t' '\n']

rule token = parse
    white+         { token lexbuf }     (* skip blanks *)
  | "true"         { BOOL true }
  | "false"        { BOOL false }
  | ident as ato   { VAR ato }
  | "&&"           { AND }
  | "||"           { OR }
  | "=>"           { IMP }
  | "<=>"          { EQ }
  | '!'            { NOT }
  | '('            { LPAREN }
  | ')'            { RPAREN }
  | eof            { EOF }

