(*
 * Partiel 2008 01
 * Question 4
 *)

type expr =
    Bool of bool
  | Not of expr
  | Or of expr * expr
  | And of expr * expr
  | Impl of expr * expr
  | Eq of expr * expr
  | Var of string

let rec eval env = function
    Bool b -> b
  | Not e -> not (eval env e)
  | Or(e1,e2) ->
      (eval env e1) || (eval env e2)
  | And(e1,e2) ->
      (eval env e1) && (eval env e2)
  | Impl(e1,e2) ->
      (not (eval env e1)) || (eval env e2)
  | Eq (e1,e2) ->
      (eval env e1) = (eval env e2)
  | Var x ->
      begin
	try
	  Hashtbl.find env x
	with
	    Not_found -> false
      end
