(*
 * Test question 3
 *)

open Question3

(* Partie test: ne pas modifier *)
let _ =
  let rec list_of_int accu = function
      0 -> 0::accu
    | n -> list_of_int (n::accu) (n-1)
  in
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let print_int_list l =
    Printf.printf "[ ";
    List.iter (Printf.printf "%d; ") l;
    Printf.printf "]\n"
  in
  let rec print_int_tree = function
      Leaf a -> Format.printf "Leaf(%d)" a
    | Node(ls,rs) ->
	Format.printf "@,Node(@[<v>";
	print_int_tree ls;
	Format.printf ",@,";
	print_int_tree rs;
	Format.printf "@]@,)"
  in
  let rec gen_tree = function
      0 -> Leaf (Random.int 10)
    | n when n>0 -> Node (gen_tree (n-1),gen_tree (n-1))
    | _ -> Printf.fprintf stderr "profondeur doit etre positif !" ; exit 2
  in
  let usage = "Prog TP: question 3\nquestion3 graine profondeur" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::size::_ ->
	    Random.init seed;
	    let t = gen_tree size in
	      Format.printf "@[<b>t = ";
	      print_int_tree t;
	      Format.printf "@]@.";
	      Format.printf "rightFirst [] t = @.";
	      print_int_list (rightFirst [] t);
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
