/*
 * Test question 7
 */

# include <unistd.h>
# include <stdio.h>
# include "cheaters.h"
# include <errno.h>

# include "question7.h"

size_t get_size(char *s)
{
  int res;
  res = (size_t)strtol(s, (char **)NULL, 10);
  if (errno==EINVAL)
    return (-1);
  return res;
}

t_image randImage(size_t size)
{
  t_image tmp = NULL;
  int alea;
  
  alea = rand();
  if (size-1) {
    if (!(alea%13))
      return NULL;
    else
      {
      	tmp = malloc(sizeof (struct s_image));
	if ((size * alea%2))
	  {
	    tmp->white = 1;
	    tmp->tl = tmp->tr = tmp->bl = tmp->br = NULL;
	  }
	else
	  {
	    tmp->white = 0;
	    tmp->tl = randImage(size-1);
	    tmp->bl = randImage(size-1);
	    tmp->tr = randImage(size-1);
	    tmp->br = randImage(size-1);
	  }
      }
  }
  else
    {
      if (alea%23)
	{
	  tmp = malloc(sizeof (struct s_image));
	  tmp->white = 1;
	  tmp->tl = tmp->tr = tmp->bl = tmp->br = NULL;
	}
    }
  return tmp;
}

void print_image(t_image img)
{
  if (img)
    {
      if (img->white)
	write(STDOUT_FILENO,"W",1);
      else
	{
	  write(STDOUT_FILENO,"Img(",4);
	  print_image(img->tl);
	  write(STDOUT_FILENO,",",1);
	  print_image(img->tr);
	  write(STDOUT_FILENO,",",1);
	  print_image(img->bl);
	  write(STDOUT_FILENO,",",1);
	  print_image(img->br);
	  write(STDOUT_FILENO,")",1);
	}
    }
  else
    write(STDOUT_FILENO,"B",1);
}

int main(int argc, char **argv)
{
  size_t size, seed;
  t_image img;
  if (argc<3)
    {
      write(STDERR_FILENO,"Prog TP: question 7\nquestion7 seed size\n",40);
      exit(2);
    }
  seed = get_size(argv[1]);
  size = get_size(argv[2]);

  srand(seed);

  img = randImage(size);
  
  print_image(img);
  write(STDERR_FILENO,"\n",1);

  if (is_white(img))
    write(STDOUT_FILENO,"The image is white.\n",20);

  exit(0);
}
