/*
 * Test question 8
 */

# include <unistd.h>
# include <stdlib.h>
# include <stdio.h>
# include <fcntl.h>
# include <sys/mman.h>
# include <sys/types.h>
# include <sys/stat.h>

# include "question8.h"

typedef struct s_lgraphe *t_lgraphe;
struct s_lgraphe {
  size_t	ordre;
  size_t	orient;
  size_t	size;
  int		trans[2]; /* c'est pas la taille qui compte */
};

t_graphe load_graphe(char *fic)
{
  t_graphe g;
  t_lgraphe lg;
  int fd, src, dst;
  size_t i = 0;
  struct stat sb;
  t_listsom ps;
  t_adj pa1;
  
  g = malloc(sizeof(struct s_graphe));
  
  fd = open(fic,O_RDONLY);
  if (fd == -1)
    {
      write(STDERR_FILENO,
	    "question8: probleme a l'ouverture du fichier.\n",46);
      exit(2);
    }

  fstat(fd, &sb);

  lg = mmap(NULL,sb.st_size,PROT_READ,MAP_NOCORE|MAP_PRIVATE,fd,0);

  g->ordre = lg -> ordre;
  g->orient = lg->orient;

  /* Init du graphe */
  /* Sommet de 1 a ordre */
  for (i = g->ordre; i > 0; i--)
    {
      ps = malloc(sizeof(struct s_som));
      ps->som = i;
      ps->succ = NULL;
      ps->suiv = g->lsom;
      g->lsom = ps;
    }

  /* ajout des transitions */
  for (i=0; i < lg->size; i++)
    {
      src = lg->trans[i*2];
      dst = lg->trans[i*2 + 1];
      ps = g->lsom;
      pa1 = malloc(sizeof(struct s_adj));
      while (ps && ps->som != src)
	ps = ps->suiv;
      pa1->suiv = ps->succ;
      ps->succ = pa1;
      ps = g->lsom;
      while (ps && ps->som != dst)
	ps = ps->suiv;
      pa1->vsom = ps;
    }
  close(fd);
  munmap(lg,sb.st_size);
  return g;
}

/* reverse:  reverse string s in place */
void reverse(char s[])
{
  int c, i, j, len;

  len = 0;
  while(s[len++]);

  for (i = 0, j = len-2; i<j; i++, j--) {
    c = s[i];
    s[i] = s[j];
    s[j] = c;
  }
}

/* itoa:  convert n to characters in s */
int itoa(int n, char s[])
{
  int i, sign;
  
  if ((sign = n) < 0)  /* record sign */
    n = -n;          /* make n positive */
  i = 0;
  do {       /* generate digits in reverse order */
    s[i++] = n % 10 + '0';   /* get next digit */
  } while ((n /= 10) > 0);     /* delete it */
  if (sign < 0)
    s[i++] = '-';
  s[i] = '\0';
  reverse(s);
  return i;
}


int main(int argc, char **argv)
{
  t_graphe g;
  int *pere, i;
  size_t s;
  char *ss;
  if (argc < 2)
    {
      write(STDERR_FILENO,"Prog TP: question 8\nquestion8 string\n",37);
      exit(2);
    }

  g = load_graphe(argv[1]);

  if (cherche_som(g,1,g->ordre,&pere))
    {
      write(STDOUT_FILENO,"BINGO!\n",7);
      s = g->ordre;
      ss = calloc(256,1);
      while (s!=1)
	{
	  i = itoa(s,ss);
	  write(STDOUT_FILENO, ss, i);
	  write(STDOUT_FILENO, " <- ",4);
	  s = pere[s];
	}
      
      write(STDOUT_FILENO,"1 \n",3);
    }

  exit(0);
}
